#include <stdio.h>
#include <errno.h>
#include <signal.h>
#include <stdlib.h>
#include <string.h>

#include <netdb.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <fcntl.h>

#include <grp.h>
#include <pwd.h>
#include <time.h>

#define PORT 2007 /*Numéro de port*/
#define MAX_CARACT 100 /*Limitation à 100 caractères par contacts*/
#define MAXCONTACTS 500 /*Limitation à 500 contacts*/
#define SERVEURNAME "127.0.0.1"

#include "client_tcp.h"
#include "mesfonctions_client.c"

int main ( void )
{
	/**Initialisation des variables + allocation de mémoire*/
	struct profil informations;
	int j=0;
	int reponse = 0;
	char msg[MAX_CARACT],destinataire[MAX_CARACT];
	char *reception,*emetteur,*message;
	reception = malloc(MAX_CARACT+1);
	emetteur = malloc(MAX_CARACT+1);
	message = malloc(MAX_CARACT+1);
	
	/**Connecte l'utilisateur au serveur*/
	informations = connexion();
	
	/**Affiche les contacts de l'utilisateur si il le souhaite*/
	printf("Voulez vous afficher vos contacts? (1 pour oui, 0 pour non)\n");
	scanf("%d",&reponse);
	if (reponse!=0)
	{
		printf("\nVous avez %d contacts\n",nb_contacts);
		while(j < nb_contacts) 
		{
			printf("Voici votre contact n°%d = %s\n",j+1,informations.contact[j]); 
			++j; 
		}
	}
	
	/**Ajoute des contacts à l'utilisateur si il le souhaite*/
	printf("Voulez vous ajouter des contacts? (1 pour oui, 0 pour non)\n");
	scanf("%d",&reponse);
	if (reponse!=0)	demande_et_ajout_contact();
	informations = actualise_donnees(-1,1);	/**Actualise la liste de contacts de l'utilisateur*/
	
	printf("Nom : %s\nEtat : %s\n", informations.nom, informations.etat);
	
	/**Envoi d'un message vers un destinataire*/
	clean(msg);
	printf("Tapez un message:");
	fgets(msg,sizeof(msg),stdin);	
	clean(msg);
	printf("Tapez le nom du destinataire:");
	fgets(destinataire,sizeof(destinataire),stdin);	
	clean(destinataire);
	envoi_msg(informations.nom,destinataire,msg);
	
	/**Ecoute et affiche ce que le serveur répond*/
	reception=recoit_chaine();
	if (!strcmp(reception,"Un_Client_Vous_Envoi"))
	{
		emetteur=recoit_chaine();
		printf("reception : L'utilisateur '%s' ",emetteur);
		message=recoit_chaine();
		printf("vous envoi : '%s'\n",message);
	}
	else	printf("reception : %s\n",reception);
	
	/**Demande à l'utilisateur si il souhaite se déconnecter*/
	printf("Voulez vous vous déconnecter? (1 pour oui, 0 pour non)\n");
	scanf("%d",&reponse);
	if (reponse!=0)	deconnexion(informations.nom);
	return EXIT_SUCCESS;
}

